package com.its.op.service.its.road;

import com.its.op.dao.repository.its.road.TbRoadTrafRepository;
import com.its.op.dao.repository.its.road.TbRoadTrafSimpleRepository;
import com.its.op.dto.its.common.TrafDto;
import com.its.op.dto.its.road.TbRoadTrafDto;
import com.its.op.entity.its.road.TbRoadTraf;
import com.its.op.entity.its.road.TbRoadTrafSimple;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRoadTrafService {

    private final TbRoadTrafRepository repo;
    private final TbRoadTrafSimpleRepository trafRepo;

    // 데이터 1건 조회, 없으면 exception
    private TbRoadTraf requireOne(Long id) throws NoSuchElementException {
        Optional<TbRoadTraf> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRoadTrafDto> findAll() {
        List<TbRoadTrafDto> result = new ArrayList<>();
        List<TbRoadTraf> data = this.repo.findAll();
        for (TbRoadTraf entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRoadTrafDto findById(Long id) {
        TbRoadTraf entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 소통정보조회
     * @return
     */
    public List<TrafDto> findAllTraf() {
        List<TrafDto> result = new ArrayList<>();
        List<TbRoadTrafSimple> data = this.trafRepo.findAll();
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }
}
